﻿namespace AoCLevelInputProvider;

using System.Reflection;

public class LevelInputProvider
{
    private const string levelFilePathTemplate = "inputs/{0}/{1}/input.txt";
    private int year;
    private int level;

    public LevelInputProvider()
    {
        this.year = 2024;
        this.level = 1;
    }

    public LevelInputProvider WithYear(int year)
    {
        this.year = year;
        return this;
    }

    public LevelInputProvider WithLevel(int level)
    {
        this.level = level;
        return this;
    }

    public string Provide()
    {
        var basePath = Path.GetDirectoryName(Assembly.GetAssembly(typeof(LevelInputProvider)).Location);
        var textPath = Path.Combine(basePath, string.Format(levelFilePathTemplate, this.year, this.level));
        return File.ReadAllText(textPath);
    }
}
